#include <iostream>
#include <vector>

using namespace std;
using ll = long long;

vector<char> colors;

void dfs(vector<vector<ll>> a, ll ver) {
	colors[ver] = 'r';
	for (ll i = 0; i < a[ver].size(); i++) {
		if (colors[a[ver][i]] != 'r') {
			dfs(a, a[ver][i]);
		}
	}
	return;
}

int main() {
	ll n;
	cin >> n;	
	vector<vector<ll>> a(n+1);
	colors.resize(n + 1);
	for (ll i = 1; i <= n; i++) {
		if ((i + i) <= n) {
			a[i].push_back((i + i));
			a[(i + i)].push_back(i);
		}
		else {
			a[i].push_back((i + i)-n);
			a[(i + i) - n].push_back(i);
		}
	}
	dfs(a, 1);
	for (ll i = n; i > 1; i--) {
		if (colors[i] != 'r') {
			cout << "NO\n" << 1 << ' ' << i << '\n';
			return 0;
		}
	}
	cout << "YES\n";
}