#include <bits/stdc++.h>

using namespace std;

struct sq{
    int x1, y1, x2, y2;
};

vector<sq> mas;
vector< vector<bool>> used;

bool ans = false;
int n, m;

bool cheak(int x, int y)
{
    if(x < 0 || y < 0 || x > n || y > m)
    {
        return false;
    }

    for(int i = 0; i < mas.size(); i++)
    {
        if(mas[i].x1 <= x && mas[i].x2 >= x && mas[i].y1 <= y && mas[i].y2 >= y)
            return false;
    }


    return true;
}

void dfs(int x, int y)
{
    //cout << x << ' ' << y << '\n';
    if((x == n && y == m) || ans)
    {
        ans = true;
        return;
    }

    if(cheak(x - 1, y) && !used[x - 1][y])
    {
        used[x - 1][y] = true;
        dfs(x - 1, y);
    }

    if(cheak(x + 1, y) && !used[x + 1][y])
    {
        used[x + 1][y] = true;
        dfs(x + 1, y);
    }

    if(cheak(x, y - 1) && !used[x][y - 1])
    {
        used[x][y - 1] = true;
        dfs(x, y - 1);
    }

    if(cheak(x, y + 1) && !used[x][y + 1])
    {
        used[x][y + 1] = true;
        dfs(x, y + 1);
    }
}

bool intersects(sq a, sq b)
{
    return(a.y1 < b.y2 || a.y2 > b.y1 || a.x2 < b.x1 || a.x1 > b.x2);
}

bool format_f3(sq a, sq b)
{
    swap(a.y1, a.y2);
    swap(b.y1, b.y2);

    return !intersects(a, b);
}

bool f1(sq q)
{
    if((q.y1 == 0 && q.y2 == m / 2) || (q.x1 == 0 && q.x2 == n / 2))
    {
        return false;
    }
    else
    {
        return true;
    }
}

void col_q(sq q, vector<bool> &mas)
{
    mas[0] = false;
    mas[1] = false;
    mas[2] = false;
    mas[3] = false;
    if(q.y2 == m / 2 || q.y1 == m / 2)
    {
        mas[1] = true;
    }
    if(q.y1 == 0 || q.y2 == 0)
    {
        mas[3] = true;
    }

    if(q.x2 == n / 2 || q.x1 == n / 2)
    {
        mas[2] = true;
    }
    if(q.x1 == 0 || q.x1 == 0)
    {
        mas[0] = true;
    }
}

bool f2(vector<bool> &mas1, vector<bool> &mas2)
{
    for(int i = 0; i < 4; i++)
    {
        for(int j = 0; j < 4; j++)
        {
            if(mas1[i] == mas2[j] && mas2[j] == true && ((i == 1 && j == 2) || (i == 1 && j == 3) || (i == 0 && j == 3) || (i == 0 && j == 2) || (i == 2 && j == 1) || (i == 3 && j == 1) || (i == 3 && j == 0) || (i == 2 && j == 0)))
            {
                return false;
            }
        }
    }
    return true;
}

vector<bool> bl;
bool anw = false;

void z(sq q, int ind, int v, vector<sq>& mas)
{
    if(ind == v || anw)
    {
        anw = true;
        return;
    }

    for(int i = 0; i < mas.size(); i++)
    {
        if(i != ind && format_f3(q, mas[i]) && !bl[i])
        {
            bl[i] = true;
            z(mas[i], i, v, mas);
        }
    }
}

int main()
{
    cin >> n >> m;
    n *= 2;
    m *= 2;

    int t;
    cin >> t;

    if(t == 1)
    {
        sq q;
        cin >> q.x1 >> q.y1 >> q.x2 >> q.y2;

        if(!f1(q))
        {
            cout << "NO" << '\n';
        }
        else
        {
            cout << "YES" << '\n';
        }
        return 0;
    }
    if(t == 2)
    {
        sq q1, q2;
        cin >> q1.x1 >> q1.y1 >> q1.x2 >> q1.y2;
        cin >> q2.x1 >> q2.y1 >> q2.x2 >> q2.y2;

        if(!f1(q1) || !f1(q2))
        {
            cout << "NO" << '\n';
            return 0;
        }

        vector<bool> mas1(4), mas2(4);
        col_q(q1, mas1);
        col_q(q2, mas2);

        if(!f2(mas1, mas2) && intersects(q1, q2))
        {
            cout << "NO" << '\n';
        }
        else
        {
            cout << "YES" << '\n';
        }

        return 0;
    }
    if(t == 3)
    {
        sq q1, q2, q3;
        cin >> q1.x1 >> q1.y1 >> q1.x2 >> q1.y2;
        cin >> q2.x1 >> q2.y1 >> q2.x2 >> q2.y2;
        cin >> q3.x1 >> q3.y1 >> q3.x2 >> q3.y2;

        if(!f1(q1) || !f1(q2) || !f1(q3))
        {
            cout << "NO" << '\n';
            return 0;
        }

        vector<bool> mas1(4), mas2(4), mas3(4);
        col_q(q1, mas1);
        col_q(q2, mas2);
        col_q(q3, mas3);

        if((!f2(mas1, mas2) && (format_f3(q1, q2) || (format_f3(q1, q3) && format_f3(q3, q2)))) || (!f2(mas1, mas3) && (format_f3(q1, q3) || (format_f3(q1, q2) && format_f3(q3, q2)))) || (!f2(mas2, mas3) && (format_f3(q2, q3) || (format_f3(q1, q2) && format_f3(q1, q3)))))
        {
            /*
            cout << format_f3(q1, q2) << ' ' << format_f3(q1, q3) << ' ' << format_f3(q3, q2) << '\n';
            if(!f2(mas1, mas2) && (format_f3(q1, q2) || (format_f3(q1, q3) && format_f3(q2, q3))))
                cout << 1 << '\n';
            if(!f2(mas1, mas3) && (format_f3(q1, q3) || (format_f3(q1, q2) && format_f3(q3, q2))))
                cout << 2 << '\n';
            if(!f2(mas2, mas3) && (format_f3(q2, q3) || (format_f3(q1, q2) && format_f3(q1, q3))))
                cout << 3 << '\n';
                */
            cout << "NO" << '\n';
        }
        else
        {
            cout << "YES" << '\n';
        }


        return 0;
    }
    if(1 <= t && t <= 1000)
    {
        vector<sq> mas;
        for(int i = 0; i < t; i++)
        {
            sq q;
            cin >> q.x1 >> q.y1 >> q.x2 >> q.y2;

            mas.push_back(q);
        }


        vector< vector<bool>> m(t);
        for(int i = 0; i < t; i++)
        {
            m[i].resize(4);
            col_q(mas[i], m[i]);
        }
        for(int i = 0; i < t; i++)
        {
            for(int j = 0; j < t; j++)
            {
                bl.resize(0);
                bl.resize(t);
                anw = false;
                z(mas[i], i, j, mas);
                if(i != j && !f2(m[i], m[j]) && anw)
                {
                    cout << "NO" << '\n';
                    return 0;
                }
            }
        }

        cout << "YES" << '\n';
        return 0;
    }

    used.resize(n + 1);

    for(int i = 0; i <= n; i++)
    {
        used[i].resize(m + 1);
    }

    for(int i = 0; i < t; i++)
    {
        sq q;
        cin >> q.x1 >> q.y1 >> q.x2 >> q.y2;
        q.x1 *= 2;
        q.y1 *= 2;
        q.x2 *= 2;
        q.y2 *= 2;
        mas.push_back(q);
    }


    used[0][0] = true;
    dfs(0, 0);

    if(ans)
    {
        cout << "YES" << '\n';
    }
    else
    {
        cout << "NO" << '\n';
    }

    return 0;
}
