#include <bits/stdc++.h>

using namespace std;

vector< pair<long long, long long>> t;
long long INF = 1000000000000000000;
long long ans = -INF;

pair<long long , long long> combine(pair<long long , long long> a, pair<long long , long long> b)
{
	long long x1 = a.first, x2 = a.second, x3 = b.first, x4 = b.second;
    vector<long long> mas;
    mas.push_back(x1);
    mas.push_back(x2);
    mas.push_back(x3);
    mas.push_back(x4);
    sort(mas.begin(), mas.end());
    return {mas[0], mas[1]};
}


void init(long long v, long long l, long long r, vector<long long> &a)
{
    if(r - l == 1)
    {
        t[v].first = a[l];
        t[v].second = INF;
        return;
    }
    long long m = (l + r) / 2;
    init(2 * v + 1, l, m, a);
    init(2 * v + 2, m, r, a);
    t[v] = combine(t[2 * v + 1], t[2 * v + 2]);
}

pair<long long, long long> answer(long long v, long long l, long long r, long long l1, long long r1)
{
    //cout << v << ' ' << l << ' ' << r << '\n';
    if(r1 <= l || r <= l1)
        return {INF, INF};
    else if(l1 <= l && r <= r1)
    {
        //cout << 1 << '\n';
        return t[v];
    }
    long long m = (l + r) / 2;
    return combine(answer(2 * v + 1, l, m, l1, r1), answer(2 * v + 2, m, r, l1, r1));
}



int main()
{
    long long n;
    cin >> n;

    vector<long long> mas(n);

    for(long long i = 0; i < n; i++)
    {
        cin >> mas[i];
    }
    //t.resize(4 * n);
    //init(0, 0, n, mas);
    vector< vector<pair<long long, long long>>> mn(n);


    for(int i = 0; i < n; i++)
    {
        mn[i].resize(n);
        mn[i][i] = {INF, mas[i]};
    }

    for(long long i = 0; i < n; i++)
    {
        for(long long j = i + 1; j < n; j++)
        {
            mn[i][j] = combine(mn[i][j - 1], {INF, mas[j]});
        }
    }


    for(long long i = 0; i < n; i++)
    {
        for(long long j = i + 1; j < n; j++)
        {
            //pair<long long, long long> a = answer(0, 0, n, i, j + 1);
            //cout << mn[i][j].first << ' ' << mn[i][j].second << ' ' << i << ' ' << j << '\n';
            ans = max(ans, (mn[i][j].first + mn[i][j].second) * (j - i + 1));
        }
    }

    cout << ans << '\n';
}
