#include <iostream>
#include <vector>
using namespace std;

long n;

void dfs(int x, vector <int>u, vector<vector<bool>>a)
{
    u[x] = 1;
    int i;
    for (i = 1; i <= n; i++)
        if (a[x][i] && !u[i])
            dfs(i,u,a);
}

int main()
{
    cin >> n;
    long i, j;
    vector <int>u(1000000);
    vector<vector<bool>>a(n + 1, vector<bool>(1000000, false));
    for (i = 1; i <= n; i++)
        for (j = 1; j <= n; j++)
            if (i * 2 > n) a[i][2 * i - n] = true;
            else a[i][2 * i] = true;
    int c = 0, l, k;
    for (i = 1; i <= n; i++)
        if (!u[i])
        {
            if (c<1) dfs(i,u,a);
            c++;
            if(c==1) l=i;
        }
    if (c == 1) cout << "YES";
    else
    {
        cout << "NO" << endl;
        for (i = 1; i <= n; i++)
            if (!u[i]) k = i;
        cout << l << " " << k;
    }
}