#include <bits/stdc++.h>
#define ll long long
#define pii pair<int, int>
#define fi first
#define se second
using namespace std;

const int N=1e6;

int n;
vector<int> a(N);

vector<pii> t(4*N, {INT_MAX, INT_MAX});
int sz=1;

void init()
{
    while(sz<N){
        sz*=2;
    }
}

void build(int x, int lx, int rx)
{
    if(lx>=N){
        return;
    }
    if(rx-lx==1){
        t[x]={a[lx], lx};
        return;
    }
    int m=(lx+rx)/2;
    build(2*x+1, lx, m);
    build(2*x+2, m, rx);
    t[x]=min(t[2*x+1], t[2*x+2]);
}

pii minimum(int l, int r, int x, int lx, int rx)
{
    if(r<=lx || rx<=l){
        return {INT_MAX, INT_MAX};
    }
    if(l<=lx && rx<=r){
        return t[x];
    }
    int m=(lx+rx)/2;
    return min(minimum(l, r, 2*x+1, lx, m), minimum(l, r, 2*x+2, m, rx));
}

void update(int pos, int val, int x, int lx, int rx)
{
    if(pos<lx || pos>=rx){
        return;
    }
    if(rx-lx==1){
        t[x].fi=val;
        return;
    }
    int m=(lx+rx)/2;
    update(pos, val, 2*x+1, lx, m);
    update(pos, val, 2*x+2, m, rx);
    t[x]=min(t[2*x+1], t[2*x+2]);
}

int main()
{
    //ios_base::sync_with_stdio(0);
    //cin.tie(0);
    //cout.tie(0);

	cin >> n;
    for(int i=0; i<n; i++){
        cin >> a[i];
    }
    init();
    build(0, 0, sz);
    ll ans=0;
    for(int l=0; l<n; l++){
        for(int r=l+1; r<n; r++){
            pii p=minimum(l, r+1, 0, 0, sz);
            update(p.se, INT_MAX, 0, 0, sz);
            pii q=minimum(l, r+1, 0, 0, sz);
            update(p.se, p.fi, 0, 0, sz);
            ans=max(ans, 1LL*(r-l+1)*(p.fi+q.fi));
        }
    }
    cout << ans;
}