n, m, k = map(int, input().split())

class Rectangle:
    def __init__(self, id):
        self.id = id


room = [['.' for _ in range(m*2+1)] for _ in range(n*2+1)]


for id in range(k):
    x1, y1, x2, y2 = map(int, input().split())
    for y_id in range(len(room)+1):
        for x_id in range(len(room[0])+1):
            if x1*2 <= y_id <= x2*2 and y1*2 <= x_id <= y2*2:
                room[y_id][x_id] = 'W'

dirs = [(0, -1), (0, 1), (1, 0), (-1, 0)]
current = (0, 0)
to_check = [(0, 0)]
t = True
while to_check:
    cell_to_check = to_check.pop(0)

    for direction_x, direction_y in dirs:
        if 0 <= direction_x + cell_to_check[0] <= len(room[0])-1 and 0 <= direction_y + cell_to_check[1] <= len(room)-1:
            if room[direction_y + cell_to_check[1]][direction_x + cell_to_check[0]] in ['.']:
                to_check.append((direction_x + cell_to_check[0], direction_y + cell_to_check[1]))
                room[direction_y + cell_to_check[1]][direction_x + cell_to_check[0]] = '!'

        else:
            continue
