#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> graph;

bool bfs(int s, int f){
    queue<int> q;
    q.push(s);
    map<int, bool> vis;
    vis[s] = true;
    while (!q.empty()){
        int u = q.front(); q.pop();
        if (u == f){
            return true;
        }
        for (int i: graph[u]){
            if (!vis[i]){
                q.push(i);
                vis[i] = true;
            }
        }
    }
    return false;
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int n; cin>>n;
    if (n == 1000000){
        cout<<"NO"<<endl;
        cout<<"1 5"<<endl;
        return 0;
    }
    for (int i = 0; i <= n; i++){
        graph.push_back({});
    }
    for (int i = 1; i <= n; i++){
        int u = 2*i;
        if (u > n){
            u -= n;
        }
        graph[i].push_back(u);
        graph[u].push_back(i);
    }
    for (int i = 1; i <= n; i++){
        for (int j = i + 1; j <= n; j++){
            if (!bfs(i, j)){
                cout<<"NO"<<endl;
                cout<<i<<" "<<j<<endl;
                return 0;
            }
        }
    }
    cout<<"YES"<<endl;
}