#include"bits/stdc++.h"
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi,bmi2,abm,popcnt")

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) begin(x),end(x)

mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

// #libs:libs

bool onLocal(){
    #ifdef LIS05ST
        return 1;
    #endif
    return 0;
}

void precalc(){

}

const int NMAX=5e3;

int leader[NMAX+5];
bool touch[4][NMAX+5];
int get(int v){
    if(leader[v]==v)return v;
    return leader[v]=get(leader[v]);
}
void unite(int u,int v){
    u=get(u);v=get(v);
    if(u==v)return;
    leader[u]=v;
    for(int i=0;i<4;i++)touch[i][v]|=touch[i][u];
}

bool collide(int x1,int y1,int x2,int y2,int X1,int Y1,int X2,int Y2){
    if(x2<X1)return 0;
    if(X2<x1)return 0;
    if(y2<Y1)return 0;
    if(Y2<y1)return 0;
    return 1;
}

#define MULTITESTS 0
void solve(int testCase){

    //    1
    // 0     2
    //    3
    int n,m,k;
    cin>>n>>m>>k;
    int x1[k],y1[k],x2[k],y2[k];
    for(int i=0;i<k;i++)leader[i]=i;
    for(int i=0;i<k;i++){
        cin>>x1[i]>>y1[i]>>x2[i]>>y2[i];
        if(x1[i]==0)touch[0][i]=1;
        if(y1[i]==0)touch[1][i]=1;
        if(x2[i]==n)touch[2][i]=1;
        if(y2[i]==m)touch[3][i]=1;
        for(int ii=0;ii<i;ii++){
            if(collide(
                x1[ii],y1[ii],x2[ii],y2[ii],
                x1[i],y1[i],x2[i],y2[i])
                )unite(i,ii);
        }
    }
    for(int i=0;i<k;i++){
        int v=get(i);
        if(touch[0][v]&&touch[1][v]){cout<<"NO\n";return;}
        if(touch[0][v]&&touch[2][v]){cout<<"NO\n";return;}
        if(touch[3][v]&&touch[1][v]){cout<<"NO\n";return;}
        if(touch[3][v]&&touch[2][v]){cout<<"NO\n";return;}
    }
    cout<<"YES\n";
}

const char* INPUT_FILE="/home/lis05st/CPv2/files/input.txt";
const char* OUTPUT_FILE="/home/lis05st/CPv2/files/output.txt";

signed main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

    if(onLocal()){
        freopen(INPUT_FILE,"r",stdin);
        freopen(OUTPUT_FILE,"w",stdout);

        time_t end_time=
        chrono::system_clock::to_time_t(chrono::system_clock::now());
    
        cout<<"Ran on "<<std::ctime(&end_time);
        cout<<"==================================\n";
    }

    precalc();
    int t=1;
    if(MULTITESTS)cin>>t;
    for(int i=1;i<=t;i++){
        auto t1=clock();
        solve(i);
        auto t2=clock();
        float delta=t2-t1;
        delta/=CLOCKS_PER_SEC;
        if(onLocal()){
            cout<<"("<<i<<")------------"<<fixed<<setprecision(2)<<delta<<"s\n";
        }
    }
}



