#include"bits/stdc++.h"
using namespace std;

#pragma GCC optimize("O3")
#pragma GCC target("avx,avx2,bmi,bmi2,abm,popcnt,lzcnt")

typedef long long ll;
typedef unsigned long long ull;
typedef long double ld;

#define all(x) begin(x),end(x)
mt19937 rng(chrono::steady_clock::now().time_since_epoch().count());

// #libs:libs

bool onLocal(){
    #ifdef LIS05ST
        return 1;
    #endif
    return 0;
}

void precalc(){

}

const int NMAX=1e6;
int a[NMAX+5];

const int LOG=20;
int table[LOG][NMAX+5];

int get(int l,int r){
    if(r<l)return 1e9+1;
    int len=r-l+1;
    int lg=31-__builtin_clz(len);
    return min(table[lg][l],table[lg][r-(1<<lg)+1]);
}

ll solve(int l,int r){
    if(l>=r){
        return 0;
    };
    int m=(l+r)/2;
    int mn1=a[m];
    int mn2=1e9;
    int L=m-1;int R=m+1;
    ll ans=0;
    while(true){
        while(L>=l&&a[L]>=mn2)L--;
        while(R<=r&&a[R]>=mn2)R++;
        if(R-L-1>=2)ans=max(ans,1ll*(mn1+mn2)*(R-L-1));
        if(L<l&&R>r)break;
        else if(L<l){
            int x=a[R];
            if(x<mn1)swap(mn1,x);
            if(x<mn2)swap(mn2,x);
            R++;
        }else if(R>r){
            int x=a[L];
            if(x<mn1)swap(mn1,x);
            if(x<mn2)swap(mn2,x);
            L--;
        }else{
            if(a[L]>=a[R]){
                int x=a[L];
                if(x<mn1)swap(mn1,x);
                if(x<mn2)swap(mn2,x);
                L--;
            }else{
                int x=a[R];
                if(x<mn1)swap(mn1,x);
                if(x<mn2)swap(mn2,x);
                R++;
            }
        }
    }

    mn1=1e9;mn2=1e9;
    for(int i=m;i<=r;i++){
        int x=a[i];
        if(x<mn1)swap(mn1,x);
        if(x<mn2)swap(mn2,x);
        if(i-m+1>=2)ans=max(ans,1ll*(mn1+mn2)*(i-m+1));
    }
    for(int i=m-1;i>=l;i--){
        int x=a[i];
        if(x<mn1)swap(mn1,x);
        if(x<mn2)swap(mn2,x);
        if(m-1-i+1>=2)ans=max(ans,1ll*(mn1+mn2)*(m-1-i+1));
    }
    return max({ans,solve(l,m-1),solve(m+1,r)});

}


#define MULTITESTS 0
void solve(int testCase){
    int n;cin>>n;
    for(int i=0;i<n;i++)cin>>a[i];
    cout<<solve(0,n-1)<<endl;
    
    
    //for(int i=0;i<n;i++)for(int ii=i;ii<n;ii++)if(get(i,ii)!=*min_element(a+i,a+ii+1))exit(1);

}

const char* INPUT_FILE="/home/lis05st/CPv2/files/input.txt";
const char* OUTPUT_FILE="/home/lis05st/CPv2/files/output.txt";

signed main(){
    ios_base::sync_with_stdio(0);cin.tie(0);cout.tie(0);

    if(onLocal()){
        freopen(INPUT_FILE,"r",stdin);
        freopen(OUTPUT_FILE,"w",stdout);

        time_t end_time=
        chrono::system_clock::to_time_t(chrono::system_clock::now());
    
        cout<<"Ran on "<<std::ctime(&end_time);
        cout<<"==================================\n";
    }

    precalc();
    int t=1;
    if(MULTITESTS)cin>>t;
    for(int i=1;i<=t;i++){
        auto t1=clock();
        solve(i);
        auto t2=clock();
        float delta=t2-t1;
        delta/=CLOCKS_PER_SEC;
        if(onLocal()){
            cout<<"("<<i<<")------------"<<fixed<<setprecision(2)<<delta<<"s\n";
        }
    }
}



