
#include <iostream>
#include <vector>
#include <algorithm>

using namespace std;

int main() {
    int n, m, k;
    cin >> n >> m >> k;

    vector<vector<int>> rectangles(k, vector<int>(4));

    for (int i = 0; i < k; i++) {
        for (int j = 0; j < 4; j++) {
            cin >> rectangles[i][j];
        }
    }

    bool canPass = true;

    for (int i = 0; i < k; i++) {
        int x1 = rectangles[i][0];
        int y1 = rectangles[i][1];
        int x2 = rectangles[i][2];
        int y2 = rectangles[i][3];

        if (x1 == 0 && y1 == 0) {
            canPass = false;
            break;
        }

        if (x2 == n && y2 == m) {
            canPass = false;
            break;
        }
    }

    if (canPass) {
        cout << "YES" << endl;
    } else {
        cout << "NO" << endl;
    }

    return 0;
}