#include <iostream>
#include <algorithm>
#include <climits>
using namespace std;

int max_subarray_price(long int n, long int a[]) {
    int max_price = -INT_MAX;
    for (int i = 0; i < n-1; i++) {
        for (int j = i+1; j < n; j++) {
            int subarray[j-i+1];
            copy(a+i, a+j+1, subarray);
            int min1 = *min_element(subarray, subarray+(j-i+1));
            int min2 = INT_MAX;
            for (int k = 0; k < j-i+1; k++) {
                if (subarray[k] < min2 && subarray[k] > min1) {
                    min2 = subarray[k];
                }
            }
            int subarray_price = (min1 + min2) * (j-i+1);
            max_price = max(max_price, subarray_price);
        }
    }
    return max_price;
}

int main() {
    long int n;
    cin >> n;
    long int a[n];
    for (int i = 0; i < n; i++) {
        cin >> a[i];
    }
    cout << max_subarray_price(n, a) << endl;
    return 0;
}
