def max_subarray_price(n, a):
    max_price = 0
    for i in range(n-1):
        min1 = a[i]
        min2 = float('inf')
        for j in range(i+1, n):
            if a[j] < min1:
                min2 = min1
                min1 = a[j]
            elif a[j] < min2:
                min2 = a[j]
            subarray_price = (min1 + min2) * (j-i+1)
            max_price = max(max_price, subarray_price)
            if max_price >= min1 * (j-i+1):
                break
    return max_price


n = int(input())
a = [int(item) for item in input().split()]
print(max_subarray_price(n, a))
