using System;
using System.Collections.Generic;
using System.Linq;

var len = long.Parse(Console.ReadLine());
var arr = Console.ReadLine().Split(' ').Select(long.Parse).ToArray();

IEnumerable<ArraySegment<long>> ComposeSubArrays(long[] arr) {
    for(int i = 0; i < arr.Length - 1; i++){
        for(int j = i + 1; j < arr.Length; j++)
            yield return new ArraySegment<long>( arr, i, j - i + 1);
    }
}

long GetCost(ArraySegment<long> arr) {
    var a = Math.Min(arr.Array[arr.Offset], arr.Array[arr.Offset + 1]);
    var b = Math.Max(arr.Array[arr.Offset], arr.Array[arr.Offset + 1]);
    for (int i = arr.Offset + 2; i < arr.Offset + arr.Count; i++) {
        long x = arr.Array[i];
        if (x <= a){
            b = a;
            a = x;
            }
        else if (x <= b) {
            b = x;
            }
    }
    return (a + b) * arr.Count;
}

//Console.WriteLine(string.Join(',', sub.Select(_ => _.ToString())));
//Console.WriteLine(GetCost(sub));
var max = long.MinValue;
foreach(var sub in ComposeSubArrays(arr)) {
    max  = Math.Max(max, GetCost(sub));
    }
Console.WriteLine(max);  
