using System;
using System.Linq;

public class Program
{
    private static int ID = 0;
    public static void Main(string[] args)
    {   
        var n = int.Parse(Console.ReadLine());


        ConnectedNodes[] connectedNodes = new ConnectedNodes[n];


        for (int i = 0; i < n; i++)
        {
            var city = i + 1;
            var connectedCity = GetNextCity(city, n);

            if(connectedNodes[city - 1] == null)
                connectedNodes[city - 1] = new ConnectedNodes();

            if (connectedNodes[connectedCity - 1] == null)
                connectedNodes[connectedCity - 1] = new ConnectedNodes();

            var cityNodes = ConnectedNodes.FindNodeWithArray(connectedNodes[city - 1]);
            var nextCityNodes = ConnectedNodes.FindNodeWithArray(connectedNodes[connectedCity - 1]);

            if (cityNodes.ID != nextCityNodes.ID)
            { 
                var node = new ConnectedNodes();
                cityNodes.NodeReference = node;
                nextCityNodes.NodeReference = node;
            }
        }


        var firstConnectedNodes = ConnectedNodes.FindNodeWithArray(connectedNodes[0]);

        for (int i = 1; i < n; i++)
        {
            var nextConnectedNodes = ConnectedNodes.FindNodeWithArray(connectedNodes[i]);
            if (firstConnectedNodes.ID != nextConnectedNodes.ID)
            {
                Console.WriteLine("NO");
                Console.WriteLine($"{1} {i + 1}");
                return;
            }
        }
       
        Console.WriteLine("YES");
    }


    public static int NextID()
    {
        ID = ID + 1;
        return ID;
    }

    public static int GetNextCity(int i, int n)
    {
        return (2 * i > n) ? 2 * i - n : 2 * i;
    }

    public class ConnectedNodes
    {
        public int ID;
        
        public ConnectedNodes NodeReference;

        public ConnectedNodes() 
        {
            ID = NextID();
        
        }

        public static ConnectedNodes FindNodeWithArray(ConnectedNodes connectedNodes)
        {
            while (connectedNodes.NodeReference != null)
            { 
                connectedNodes = connectedNodes.NodeReference;
            }

            return connectedNodes;
        }
    }

    

    public static int[] SplitString(string input)
    {
        var words = input.Split(' ');
        var numbers = new int[words.Length];

        for (int i = 0; i < words.Length; i++)
        {
            numbers[i] = int.Parse(words[i]);
        }

        return numbers;
    }

}

