#include <bits/stdc++.h>

using namespace std;
using ll = long long;

ll n, m, n1, m1, q, k, x, y, a, b, c;
vector< vector<ll> > open;

bool avail(ll x, ll y) {
    // cout << '\t' << x << ' ' << y << endl;
    if (x < 0 || x >= n) {
        return 0;
    }
    if (y < 0 || y >= m) {
        return 0;
    }
    return !open[x][y];
}

void dfs(ll x, ll y) {
    // cout << x << ' ' << y << endl;
    open[x][y] = 1;
    // cout << open.size() << ' ' << open[0].size() << endl;
    if (avail(x - 1, y)) {
        dfs(x - 1, y);
    }
    if (avail(x + 1, y)) {
        dfs(x + 1, y);
    }
    if (avail(x, y - 1)) {
        dfs(x, y - 1);
    }
    if (avail(x, y + 1)) {
        dfs(x, y + 1);
    }
}

void solve() {
    cin >> n1 >> m1 >> k;
    n1++;
    m1++;
    vector<ll> x1(k);
    vector<ll> x2(k);
    vector<ll> y1(k);
    vector<ll> y2(k);
    set<ll> evx;
    set<ll> evy;
    map<ll, ll> to_x;
    map<ll, ll> to_y;
    for (int i = 0; i < k; i++) {
        cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
        evx.insert(x1[i]);
        evx.insert(x2[i]);
        evy.insert(y1[i]);
        evy.insert(y2[i]);
    }
    n = 1;
    to_x[0] = 0;
    for (int i = 1; i < n1; i++) {
        if (evx.count(i)) {
            n++;
        }
        to_x[i] = n - 1;
    }
    m = 1;
    to_y[0] = 0;
    for (int i = 1; i < m1; i++) {
        if (evy.count(i)) {
            m++;
        }
        to_y[i] = m - 1;
    }
    vector< pair< pair<ll, ll>, pair<ll, ll> > > events;
    n--;
    m--;
    // cout << n << ' ' << m << '\n';
    for (int i = 0; i < k; i++) {
        x1[i] = to_x[x1[i]];
        x2[i] = to_x[x2[i]];
        y1[i] = to_y[y1[i]];
        y2[i] = to_y[y2[i]];
        // cout << x1[i] << ' ' << y1[i] << '\t' << x2[i] << ' ' << y2[i] << '\n';
        events.push_back({{x1[i], 1}, {y1[i], y2[i]}});
        events.push_back({{x2[i], -1}, {y1[i], y2[i]}});
    }
    sort(events.begin(), events.end());
    ll pos = 0;
    open.assign(n, vector<ll>(m));
    vector<ll> vec(m);
    for (int i = 0; i < n; i++) {
        // if (pos < events.size()) {
        //     cout << pos << ' ' << i << ' ' << events[pos].first.first << '\n';
        // }
        while (pos < events.size() && events[pos].first.first == i) {
            for (int j = events[pos].second.first; j < events[pos].second.second; j++) {
                vec[j] += events[pos].first.second;
            }
            pos++;
        }
        for (int j = 0; j < m; j++) {
            open[i][j] = min(1LL, vec[j]);
        }
    }
    // for (int i = 0; i < n; i++) {
    //     for (int j = 0; j < m; j++) {
    //         cout << open[i][j] << ' ';
    //     }
    //     cout << '\n';
    // }
    dfs(0, 0);
    if (open[n - 1][m - 1]) {
        cout << "YES\n";
    }
    else {
        cout << "NO\n";
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    solve();
}
