#include <bits/stdc++.h>

using namespace std;

struct Tval
{
    long long firstMin,secondMin;
};

Tval tree[10000000];

Tval build_tree(int a[],int pos,int left,int right)
{
    if(left==right)
    {
        tree[pos].firstMin=a[left];
        tree[pos].secondMin=INT_MAX;
        return tree[pos];
    }
    int mid=(left+right)/2;
    Tval leftRes=build_tree(a,pos<<1,left,mid);
    Tval rightRes=build_tree(a,(pos<<1)+1,mid+1,right);
    tree[pos].firstMin=min(leftRes.firstMin,rightRes.firstMin);
    tree[pos].secondMin=min(max(leftRes.firstMin,rightRes.firstMin),min(leftRes.secondMin,rightRes.secondMin));
    return tree[pos];
}

Tval find_min(int l_arr,int r_arr,int l_tree,int r_tree,int pos)
{
    if(l_arr<=l_tree&&r_arr>=r_tree)
        return tree[pos];

    int mid=(l_tree+r_tree)/2;

    if(r_arr<=mid) return find_min(l_arr,r_arr,l_tree,mid,pos<<1);
    if(l_arr>=mid+1) return find_min(l_arr,r_arr,mid+1,r_tree,(pos<<1)+1);

    Tval leftRes=find_min(l_arr,r_arr,l_tree,mid,pos<<1);
    Tval rightRes=find_min(l_arr,r_arr,mid+1,r_tree,(pos<<1)+1);

    Tval res;
    res.firstMin=min(leftRes.firstMin,rightRes.firstMin);
    res.secondMin=min(max(leftRes.firstMin,rightRes.firstMin),min(leftRes.secondMin,rightRes.secondMin));
    
    return res;
}

void inp_arr(int a[],int &n)
{
    cin >> n;
    for(int i=1;i<=n;++i)
        cin >> a[i];
}

int a[1000000];

int main()
{
    int n;
    inp_arr(a,n);
    build_tree(a,1,1,n);

    long long res=LONG_MIN; Tval temp;
    for(long long i=2;i<=n;++i)
    {
        for(int j=1;j<=n-i+1;++j)
        {
            temp=find_min(j,j+i-1,1,n,1);
            res=max(res,(temp.firstMin+temp.secondMin)*i);
        }
    }
    cout << res;
    return 0;
}