import math
import random

def circle_check(obj_x, obj_y, circle_x, circle_r):
    distance = math.sqrt(math.pow((circle_x - obj_x), 2) + math.pow((0 - obj_y), 2))
    return True if distance <= circle_r else False

    
n, dog_x, dog_y, hive_x, hive_y = map(int, input().split())
domes = []
for _ in range(n): 
    domes += [[int(elem) for elem in input().split()]]

# print(domes)

# print(circle_check(dog_x, dog_y, domes[0][0], domes[0][1]))
# print(circle_check(hive_x, hive_y, domes[0][0], domes[0][1]))

dog_dome = 0
hive_dome = 0

for i in range(n):
    dog = circle_check(dog_x, dog_y, domes[i][0], domes[i][1])
    hive = circle_check(hive_x, hive_y, domes[i][0], domes[i][1])
    
    if dog:
        dog_dome = i + 1
    if hive:
        hive_dome = i + 1
    
    # print(dog, hive)

# print(dog_dome, hive_dome)

if dog_dome == hive_dome:
    print("YES")
else:
    print("NO")
    print(random.randint(2,3))