using System;
using System.Linq;

class Solution {
  public static void Main(string[] args) {
      int n = Convert.ToInt32(Console.ReadLine());
      int[] array = Console.ReadLine().Split(" ").Select(n => int.Parse(n)).ToArray();

      int currentMaxValue = 0;
      for(int i = 0; i < array.Length; i++)
      {
        if(i == array.Length - 1) break;
        var otherEnd = 0;

        for(int j = 0; j < array.Length - i - 1; j++)
        {
          otherEnd = i + j;

          var length = GetLength(i, otherEnd);
          var subArray = new int[length + 1];
          Array.Copy(array, i, subArray, 0, length + 1);
          var sum = GetArrayValue(subArray);

          if(sum > currentMaxValue) currentMaxValue = sum;
          if(sum == currentMaxValue) continue;
          if(sum < currentMaxValue) break;
        }
      }

      Console.WriteLine(currentMaxValue);
  }

  public static int GetLength(int i, int j)
  {
    return Math.Abs(i - j) + 1;
  }

  public static int GetArrayValue(int[] array)
  {
    var length = array.Length;
    var minList = array.OrderBy(n => n).ToArray();
    var min1 = minList[0];
    var min2 = minList[1];

    // Console.WriteLine(string.Join(" ", array));
    // Console.WriteLine($"{length} * ({min1} + {min2})");
    // Console.WriteLine(length * (min1 + min2));

    return length * (min1 + min2);
  }
}
