#include <bits/stdc++.h>
using namespace std;

vector<vector<int>> adj;
vector<bool> visited;

void dfs(int v)
{
    visited[v] = true;

    for (int u : adj[v])
        if (!visited[u])
            dfs(u);
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n;
    cin >> n;

    adj.resize(n + 1);
    visited.resize(n + 1);

    for (int i = 1; i <= n; i++)
    {
        int d = i + i <= n ? i + i : i + i - n;

        adj[i].push_back(d);
        adj[d].push_back(i);
    }

    dfs(1);

    for (int i = 1; i <= n; i++)
        if (!visited[i])
        {
            cout << "NO" << endl
                 << 1 << " " << i;

            return 0;
        }

    cout << "YES";
}
