#include <bits/stdc++.h>
using namespace std;

bool check(double x, double y, int n, int m, vector<double> &x1, vector<double> &y1, vector<double> &x2, vector<double> &y2)
{
    if (x < 0 || x > n || y < 0 || y > m)
        return 0;
    for (int i = 0; i < x1.size(); i++)
        if (x1[i] <= x && x <= x2[i] && y1[i] <= y && y <= y2[i])
            return 0;
    return 1;
}

int main()
{
    int n, m, k;
    bool ans;
    cin >> n >> m >> k;
    vector<double> x1(k), y1(k), x2(k), y2(k);
    for (int i = 0; i < k; i++)
        cin >> x1[i] >> y1[i] >> x2[i] >> y2[i];
    queue<pair<double, double>> q;
    vector<vector<bool>> vis(2 * n + 1, vector<bool>(2 * m + 1, false));
    q.push({0, 0});
    while (q.size())
    {
        pair<double, double> t = q.front();
        q.pop();
        int x = t.first * 2, y = t.second * 2;
        if (vis[x][y])
            continue;
        vis[x][y] = 1;
        if (t.first == n && t.second == m)
        {
            ans = 1;
            break;
        }
        if (check(t.first - 0.5, t.second, n, m, x1, y1, x2, y2))
            q.push({t.first - 0.5, t.second});
        if (check(t.first + 0.5, t.second, n, m, x1, y1, x2, y2))
            q.push({t.first + 0.5, t.second});
        if (check(t.first, t.second - 0.5, n, m, x1, y1, x2, y2))
            q.push({t.first, t.second - 0.5});
        if (check(t.first, t.second + 0.5, n, m, x1, y1, x2, y2))
            q.push({t.first, t.second + 0.5});
    }
    if (ans)
        cout << "YES";
    else
        cout << "NO";
    return 0;
}
