#include <iostream>
#include <vector>

using namespace std;
vector<int> graph[100000];
bool used[100000];
vector<int> comp;

void dfs(int v) {
    used[v] = true;
    comp.push_back(v);
    for (int i = 0; i < graph[v].size(); ++i) {
        int a = graph[v][i];
        if (!used[a])
            dfs(a);
    }
}

int main() {
    int n;
    cin >> n;
    int cnt = 0;
    int x, y;
    graph[1].push_back(2);
    graph[2].push_back(1);
    for (int i = 3; i < n; ++i) {
        x = i;
        if (x + x <= n)
            y = x + x - n;
        else
            y = x + x;
        x--, y--;

        graph[x].push_back(y);
        graph[y].push_back(x);
    }
    cout << "NO" << endl;
    for (int i = 0; i < n; i+=n-1) {
        if (!used[i]) {
            dfs(i), cnt++;
            for (auto it: comp) {
                cout << it + 1 << ' ';
            }
            cout << endl;
        }
        comp.resize(0); 
    }
}