#include <bits/stdc++.h>

using namespace std;

struct sq{
    int x1, y1, x2, y2;
};

vector<sq> mas;
vector< vector<bool>> used;

bool ans = false;
int n, m;

bool cheak(int x, int y)
{
    if(x < 0 || y < 0 || x > n || y > m)
    {
        return false;
    }

    for(int i = 0; i < mas.size(); i++)
    {
        if(mas[i].x1 <= x && mas[i].x2 >= x && mas[i].y1 <= y && mas[i].y2 >= y)
            return false;
    }


    return true;
}

void dfs(int x, int y)
{
    //cout << x << ' ' << y << '\n';
    if((x == n && y == m) || ans)
    {
        ans = true;
        return;
    }

    if(cheak(x - 1, y) && !used[x - 1][y])
    {
        used[x - 1][y] = true;
        dfs(x - 1, y);
    }

    if(cheak(x + 1, y) && !used[x + 1][y])
    {
        used[x + 1][y] = true;
        dfs(x + 1, y);
    }

    if(cheak(x, y - 1) && !used[x][y - 1])
    {
        used[x][y - 1] = true;
        dfs(x, y - 1);
    }

    if(cheak(x, y + 1) && !used[x][y + 1])
    {
        used[x][y + 1] = true;
        dfs(x, y + 1);
    }
}

bool pt_in_q(int x, int y, sq q)
{
     if(q.x1 <= x && q.x2 >= x && q.y1 <= y && q.y2 >= y)
            return true;
     return false;
}

bool cheak_q(sq q1, sq q2)
{
    if(pt_in_q(q1.x1, q1.y1, q2) || pt_in_q(q1.x2, q1.y2, q2) || pt_in_q(q1.x1, q1.y2, q2) || pt_in_q(q1.x2, q1.y1, q2))
    {
        return true;
    }
    return false;
}

int main()
{
    cin >> n >> m;
    n *= 2;
    m *= 2;

    int t;
    cin >> t;

    if(t == 1)
    {
        sq q;
        cin >> q.x1 >> q.y1 >> q.x2 >> q.y2;

        if((q.y1 == 0 && q.y2 == m / 2) || (q.x1 == 0 && q.x2 == n / 2)){
            cout << "NO" << '\n';
        }
        else
        {
            cout << "YES" << '\n';
        }

        return 0;
    }
    if(t == 2)
    {
        sq q1, q2;
        cin >> q1.x1 >> q1.y1 >> q1.x2 >> q1.y2;
        cin >> q2.x1 >> q2.y1 >> q2.x2 >> q2.y2;

        if((q1.x2 + q2.x2 - q2.x1 - q1.x1 == n / 2 || q1.y2 + q2.y2 - q2.y1 - q1.y1 == m / 2) && cheak_q(q1, q2)){
            cout << "NO" << '\n';
        }
        else
        {
            cout << "YES" << '\n';
        }

        return 0;
    }

    used.resize(n + 1);

    for(int i = 0; i <= n; i++)
    {
        used[i].resize(m + 1);
    }

    for(int i = 0; i < t; i++)
    {
        sq q;
        cin >> q.x1 >> q.y1 >> q.x2 >> q.y2;
        q.x1 *= 2;
        q.y1 *= 2;
        q.x2 *= 2;
        q.y2 *= 2;
        mas.push_back(q);
    }


    used[0][0] = true;
    dfs(0, 0);

    if(ans)
    {
        cout << "YES" << '\n';
    }
    else
    {
        cout << "NO" << '\n';
    }

    return 0;
}
