#include <bits/stdc++.h>
using namespace std;

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	int n, m, k;
    cin >> n >> m >> k;
    vector<int> i1(k+1), j1(k+1), i2(k+1), j2(k+1);
    for(int i=1; i<=k; i++){
        cin >> i1[i] >> j1[i] >> i2[i] >> j2[i];
    }
    function<bool(int, int)> intersect=[&](int i, int j){
        bool res=1;
        if(j1[i]>j2[j]){
            res=0;
        }
        if(j1[j]>j2[i]){
            res=0;
        }
        if(i1[i]>i2[j]){
            res=0;
        }
        if(i1[j]>i2[i]){
            res=0;
        }
        return res;
    };
    vector<vector<int> > g(k+1);
    for(int i=1; i<=k; i++){
        for(int j=i+1; j<=k; j++){
            if(intersect(i, j)){
                g[i].push_back(j);
                g[j].push_back(i);
            }
        }
    }
    for(int i=1; i<=k; i++){
        if(i1[i]==0){
            g[0].push_back(i);
        }
    }
    vector<bool> vis(k+1, 0);
    queue<int> q;
    q.push(0);
    while(!q.empty()){
        int v=q.front();
        q.pop();
        if(i2[v]==n){
            cout << "NO";
            return 0;
        }
        for(int u: g[v]){
            if(!vis[u]){
                vis[u]=1;
                q.push(u);
            }
        }
    }
    g[0].clear();
    for(int i=1; i<=k; i++){
        if(j1[i]==0){
            g[0].push_back(i);
        }
    }
    vis.assign(k+1, 0);
    q.push(0);
    while(!q.empty()){
        int v=q.front();
        q.pop();
        if(j2[v]==m){
            cout << "NO";
            return 0;
        }
        for(int u: g[v]){
            if(!vis[u]){
                vis[u]=1;
                q.push(u);
            }
        }
    }
    cout << "YES";
}
