n = int(input())

disconnected = set()
pairs = []
for i in range(1, n+1):
    if i*2 <= n:
        pairs.append((i, i*2))
        disconnected = {x for x in disconnected if x not in (i, i*2)}

    elif i*2 - n <= n:
        pairs.append((i, i*2 - n))
        disconnected = {x for x in disconnected if x not in (i, i*2-n)}

    else:
        disconnected.add(i)


if len(disconnected) > 0:
    print(f"NO\n1 {disconnected[-1]}")

else:

    def is_connected_to_other_cities(road_left, road_right, visited: set, connect):
        connect.add(road_left)
        connect.add(road_right)

        visited.add((road_left, road_right))

        for pair in pairs:
            if pair in visited:
                continue

            if road_right not in pair and road_left not in pair:
                continue

            else:
                connect |= is_connected_to_other_cities(pair[0], pair[1], visited, connect)
        return connect

    is_connected = True

    cities_connected_to = is_connected_to_other_cities(pairs[0][0], pairs[0][1], set(), set())

    if len(cities_connected_to) != n:
        not_connected = (set(range(1, n+1)) - cities_connected_to).pop()
        print(f"NO\n{list(cities_connected_to)[0]} {not_connected}")
        is_connected = False

    if is_connected:
        print("YES")
