#include <iostream>
#include <set>
#include <vector>
#include <climits>
#include <string>
#include <algorithm>
#include <cmath>
#include <map>

using namespace std;

typedef long long ll;
typedef long long ull;
typedef pair<int, int> pint;
typedef pair<ll, ll> pll;
typedef pair<double, double> pd;

vector<pd> v;

vector<bool> calc(int x, int y)
{
    vector<bool> res;
    for (int i = 0; i < v.size(); i++)
    {
        double dist = sqrt((v[i].first - x) * (v[i].first - x) + y * y);
        if (dist <= v[i].second) res.push_back(true);
        else res.push_back(false);
    }
    return res;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int n; double x1, x2, y1, y2;
    cin >> n >> x1 >> y1 >> x2 >> y2;
    for (int i = 0; i < n; i++)
    {
        double x, r;
        cin >> x >> r;
        v.push_back(pd(x, r));
    }
    vector<bool> v1 = calc(x1, y1), v2 = calc(x2, y2);
    bool ok = true;
    int col = 0;
    for (int i = 0; i < n; i++)
    {
        if (v1[i] != v2[i])
        {
            col = i;
            ok = false;
            break;
        }
    }
    if (ok) cout << "YES\n";
    else cout << "NO\n" << col + 1 << "\n";
}