#include <bits/stdc++.h>
using namespace std;

struct rec{
    int x1, y1, x2, y2;
};

map<pair<int, int>, bool> vis;
int n, m, k;

vector<rec> d;

bool check(int x, int y){
    for (auto i: d){
        if (i.x1 < x && x <= i.x2 && i.y1 < y && y <= i.y2){
            return true;
        }
    }
    return false;
}

void bfs(){
    queue<pair<int, int>> q;
    q.push({1, 1});
    vis[{1, 1}] = true;
    while (!q.empty()){
        pair<int, int> b = q.front(), c = b; q.pop();
        if (b.first == n && b.second == m){
            cout<<"YES";
            exit(0);
        }
        while (b.first <= n && !check(b.first, b.second)){
            b.first++;
        }
        b.first -= check(b.first, b.second);
        if (b.first == n + 1){
            b.first--;
        }
        if (!vis[{b.first, b.second}]){
            q.push({b.first, b.second});
            vis[{b.first, b.second}] = true;
        }
        else {
            while (c.second <= m && !check(c.first, c.second)){
                c.second++;
            }
            c.second -= check(c.first, c.second);
            if (c.second == m + 1){
                c.second--;
            }
            if (!vis[{c.first, c.second}]){
                q.push({c.first, c.second});
                vis[{c.first, c.second}] = true;
            }
        }
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    rec add;
	cin>>n>>m>>k;
    for (int i = 0; i < k; i++){
        cin>>add.x1>>add.y1>>add.x2>>add.y2;
        d.push_back(add);
    }
    bfs();
    cout<<"NO";
}