#include <bits/stdc++.h>
using namespace std;

struct rec{
    int x1, y1, x2, y2;
};

bool cmp(rec a, rec b){
    if (a.x1 != b.x1){
        return (a.x1 < b.x1);
    }
    if (a.x2 != b.x2){
        return (a.x2 < b.x2);
    }
    if (a.y1 != b.y1){
        return (a.y1 < b.y1);
    }
    return (a.y2 < b.y2);
}

map<pair<int, int>, bool> vis;
int n, m, k;

vector<rec> d;

bool check(int x, int y){
    int l = 0, r = k - 1;
    while (l < r){
        int mid = (l + r) / 2;
        //cout<<l<<" "<<r<<" "<<mid<<endl;
        rec cur = d[mid];
        if (cur.x1 >= x){
            r = mid - 1;
        }
        else if (cur.x2 < x){
            l = mid + 1;
        }
        else {
            if (cur.y1 >= y){
                r = mid - 1;
            }
            else if (cur.y2 < y){
                l = mid + 1;
            }
            else {
                return true;
            }
        }
    }
    if (k == 2){
        return (d[0].x1 < x && x <= d[0].x2 && d[0].y1 < y && y <= d[0].y2) || (d[1].x1 < x && x <= d[1].x2 && d[1].y1 < y && y <= d[1].y2);
    }
    return (d[l].x1 < x && x <= d[l].x2 && d[l].y1 < y && y <= d[l].y2);
}

void bfs(){
    queue<pair<int, int>> q;
    q.push({1, 1});
    vis[{1, 1}] = true;
    while (!q.empty()){
        pair<int, int> b = q.front(), c = b; q.pop();
        //cout<<b.first<<" "<<b.second<<endl;
        if (b.first == n && b.second == m){
            cout<<"YES";
            exit(0);
        }
        while (b.first <= n && !check(b.first, b.second)){
            b.first++;
        }
        b.first -= check(b.first, b.second);
        if (b.first == n + 1){
            b.first--;
        }
        if (!vis[{b.first, b.second}]){
            q.push({b.first, b.second});
            vis[{b.first, b.second}] = true;
        }
        while (c.second <= m && !check(c.first, c.second)){
            c.second++;
        }
        c.second -= check(c.first, c.second);
        if (c.second == m + 1){
            c.second--;
        }
        if (!vis[{c.first, c.second}]){
            q.push({c.first, c.second});
            vis[{c.first, c.second}] = true;
        }
        //cout<<b.first<<" "<<b.second<<endl;
        //cout<<c.first<<" "<<c.second<<endl;
        //cout<<endl;
    }
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    rec add;
	cin>>n>>m>>k;
    for (int i = 0; i < k; i++){
        cin>>add.x1>>add.y1>>add.x2>>add.y2;
        d.push_back(add);
    }
    sort(d.begin(), d.end(), cmp);
    /*
    for (auto i: d){
        cout<<i.x1<<" "<<i.x2<<" "<<i.y1<<" "<<i.y2<<endl;
    }
    */
    bfs();
    cout<<"NO";
}