#include <bits/stdc++.h>

#define fr first
#define sc second
#define pb push_back

using namespace std;
typedef long long ll;
typedef string str;
typedef pair<ll, ll> pll;
typedef pair<pll, pll> ppp;
const ll MAXNUM = 1000007, INF=100000007;

ll n, m, k, p, a[MAXNUM];
pll TL[MAXNUM*4], pos[MAXNUM];

pll unite(pll b1, pll b2){
    if(b1.fr>b2.fr) swap(b1, b2);
    if(b1.sc<=b2.fr) return b1;
    return {b1.fr, b2.fr};
}

void build(ll v,ll tl,ll tr){
    if(tl==tr) {TL[v] = {a[tl], INF}; return;}
    ll tm = (tl+tr)/2;
    build(v*2+1, tl, tm);
    build(v*2+2, tm+1, tr);
    TL[v] = unite(TL[2*v+1], TL[2*v+2]);
}

pll findMin(ll v,ll tl,ll tr,ll l,ll r){
    if(tl>r || tr<l) return {INF, INF};
    if(tl>=l && tr<=r) return TL[v];

    ll tm = (tl+tr)/2;
    return unite(findMin(2*v+1, tl, tm, l, r), findMin(2*v+2, tm+1, tr, l, r));
}

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

	cin >> n;
    for(int i=1; i<=n; i++) {cin >> a[i]; pos[i] = {a[i], i};}
    sort(pos+1, pos+1+n);
    vector<ll> minadd;
    minadd.pb(pos[1].sc);
    minadd.pb(pos[2].sc);
    build(0, 1, n);
    pll mi;
    mi = findMin(0, 1, n, 1, n);
    ll ma=n*(mi.fr+mi.sc), posit;
    for(int i=3; i<=n; i++){
        auto posit = lower_bound(minadd.begin(), minadd.end(), pos[i].sc);
        ll posid = posit - minadd.begin();
        
        if(posid==0) {
            mi = findMin(0, 1, n, 1, minadd[posid+1]); 
            ma=max(ma, minadd[posid+1]*(mi.fr+mi.sc));
        }
        else if(posid == minadd.size()){
            mi = findMin(0, 1, n, minadd[posid-2]+1, n); 
            ma=max(ma, (n-minadd[posid-2])*(mi.fr+mi.sc));
        }
        else if(minadd.size()==2){
            mi = findMin(0, 1, n, 1, minadd[posid]-1); 
            ma=max(ma, (minadd[posid]-1)*(mi.fr+mi.sc));
            mi = findMin(0, 1, n, minadd[posid-1]+1, n); 
            ma=max(ma, (n-minadd[posid-1])*(mi.fr+mi.sc));
        }
        else if(posid==1){
            mi = findMin(0, 1, n, 1, minadd[posid]-1); 
            ma=max(ma, (minadd[posid]-1)*(mi.fr+mi.sc));
            mi = findMin(0, 1, n, minadd[posid-1]+1, minadd[posid+1]-1); 
            ma=max(ma, (minadd[posid+1]-1-minadd[posid-1])*(mi.fr+mi.sc));
        }
        else if(posid==minadd.size()-1){
            mi = findMin(0, 1, n, minadd[posid-2]+1, minadd[posid]-1); 
            ma=max(ma, (minadd[posid]-1-minadd[posid-2])*(mi.fr+mi.sc));
            mi = findMin(0, 1, n, minadd[posid-1]+1, n); 
            ma=max(ma, (n-minadd[posid-1])*(mi.fr+mi.sc));
        }
        else{
            
            mi = findMin(0, 1, n, minadd[posid-2]+1, minadd[posid]-1); 
            ma=max(ma, (minadd[posid]-1-minadd[posid-2])*(mi.fr+mi.sc));
            mi = findMin(0, 1, n, minadd[posid-1]+1, minadd[posid+1]-1); 
            ma=max(ma, (minadd[posid+1]-1-minadd[posid-1])*(mi.fr+mi.sc));
        }
        minadd.insert(posit, pos[i].sc); 
    }
    cout << ma;
    return 0;
}