#include <bits/stdc++.h>

const int N = 1e6 + 10;

using namespace std;
typedef long long ll;
typedef pair<int, int> pi;

int dsu[N];

int find(int v){
    if(dsu[v] == v) return v;
    return dsu[v] = find(dsu[v]);
}

void merge(int u, int v){
    u = find(u);
    v = find(v);
    if(u == v) return;
    dsu[v] = u;
}

int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    int n;
    cin >> n;
    for(int i = 0; i <= n; ++i)
        dsu[i] = i;
    for(int i = 1; i <= n; ++i){
        merge(i, i * 2 % n);
    }
    int u1 = find(0);
    for(int i = 1; i < n; ++i)
        if(find(i) != u1){
            if(u1 == 0)
                u1 = n;
            cout << "NO\n"
                 << u1 << ' ' << i << '\n';
            return 0;
        }
    cout << "YES\n";
}
