#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include <ext/pb_ds/tree_policy.hpp>
using namespace std;
using namespace __gnu_pbds;
typedef long long ll;
constexpr ll mod = 1e9+7;
int p[5007];
int sz[5007];
int mn_x[5007];
int mx_x[5007];
int mx_y[5007];
int mn_y[5007];
int pr(int v){
    if(p[v] == v) return v;
    return p[v] = pr(p[v]);
}
void un(int u,int v){
    u = pr(u);
    v = pr(v);
    if(u == v) return;
    if(sz[u] > sz[v]) swap(u,v);
    sz[v]+=sz[u];
    p[u] = v;
}
bool inter(int x1,int x2,int x3,int x4){
    return (x1 <= x3 and x3 <= x2) or (x1 <= x4 and x4 <= x2) or (x3 <= x1 and x1 <= x4) or (x3 <= x2 and x2 <= x4);
}
bool inter(pair<int,int> x1,pair<int,int> x2,pair<int,int> x3,pair<int,int> x4){
    return inter(x1.first,x2.first,x3.first,x4.first) and inter(x1.second,x2.second,x3.second,x4.second);
}
void solve(){
    int n,m,k;
    cin >> n >> m >> k;
    for (int i = 0; i < k; ++i) {
        sz[i] = 1;
        p[i] = i;
        mn_x[i] = n+m+1;
        mn_y[i] = n+m+1;
    }
    vector<pair<int,int>> a(k);
    vector<pair<int,int>> b(k);
    for (int i = 0; i < k; ++i) {
        cin >> a[i].first >> a[i].second >> b[i].first >> b[i].second;
        if(a[i].first > b[i].first) swap(a[i].first,b[i].first);
        if(a[i].second > b[i].second) swap(a[i].second,b[i].second);
    }
    for (int i = 0; i < k; ++i) {
        for (int j = i+1; j < k; ++j) {
            if(inter(a[i],b[i],a[j],b[j])) un(i,j);
        }
    }
    vector<int> g;
    for (int i = 0; i < k; ++i) {
        if(p[i] == i) g.push_back(i);
        int P = pr(i);
        mn_x[P] = min(mn_x[P],a[i].first);
        mn_y[P] = min(mn_y[P],a[i].second);
        mx_x[P] = max(mx_x[P],b[i].first);
        mx_y[P] = max(mx_y[P],b[i].second);
    }
    for (int i = 0; i < g.size(); ++i) {
        int v = g[i];
        if(mn_x[v] == 0 and mx_x[v] == n){
            cout << "NO\n";
            return;
        }
        if(mn_x[v] == 0 and mn_y[v] == 0){
            cout << "NO\n";
            return;
        }
        if(mx_x[v] == n and mx_y[v] == m){
            cout << "NO\n";
            return;
        }
        if(mn_y[v] == 0 and mx_y[v] == m){
            cout << "NO\n";
            return;
        }
    }
    cout << "YES\n";
}
int main(){
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t = 1;
    //cin >> t;
    while(t--) solve();
    return 0;
}