using System;

public class Program
{
    public static void Main(string[] args)
    {
        bool matchFound = false;
        int[] firstRow = SplitString(Console.ReadLine());
        int index = 0;
        int n = firstRow[0];
        int x1 = firstRow[1];
        int y1 = firstRow[2];
        int x2 = firstRow[3];
        int y2 = firstRow[4];

        Circle[] circles = new Circle[n];

        for (int i = 0; i < n; i++)
        {
            int[] row = SplitString(Console.ReadLine());
            int p = row[0];
            int r = row[1];

            circles[i] = new Circle(p, r);
        }

        for (int i = 0; i < n; i++)
        {
            int p = circles[i].P;
            int r = circles[i].R;
            bool isOutside1 = IsOutSide(x1, y1, p, r);
            bool isOutside2 = IsOutSide(x2, y2, p, r);

            if (((isOutside1 == false) && (isOutside2 == true)) || ((isOutside2 == false) && (isOutside1 == true)))
            { 
                matchFound= true;
                index = i + 1;
                break;
            }
        }

        if (matchFound)
        {
            Console.WriteLine("NO");
            Console.WriteLine(index);

        }
        else
        {
            Console.WriteLine("YES");
        }
    }

    public static bool IsOutSide(int x, int y, int p, int r)
    {
        var distance =y*y + (x - p) * (x - p) - r * r;
        return (distance > 0);
    }

    public class Circle
    {
        public int P;
        public int R;

        public Circle(int p, int r) 
        { 
            P= p;
            R= r;
        }
    }

    public static int[] SplitString(string input)
    {
        var words = input.Split(' ');
        var numbers = new int[words.Length];

        for (int i = 0; i < words.Length; i++)
        {
            numbers[i] = int.Parse(words[i]);
        }

        return numbers;
    }

}
