#include <bits/stdc++.h>

using namespace std;

#define mp make_pair
#define pb push_back
#define all(a) (a).begin(), (a).end()
#define sz(a) (int)(a.size())
//#define endl '\n'
#define F first
#define S second
#define rs resize

using ll = long long;
using ld = long double;
using str = string;
using pi = pair<int, int>;
using pl = pair<ll, ll>;
using ppi = pair<int, pair<int, int>>;
using ppl = pair<ll, pair<ll, ll>>;
using vi = vector<int>;
using vl = vector<ll>;
using vpi = vector<pair<int, int>>;
using vvi = vector<vi>;
using vvpi = vector<vpi>;
using vpl = vector<pl>;
using vvl = vector<vl>;
using vvpl = vector<vpl>;
using vppl = vector<ppl>;
using vppi = vector<ppi>;
using ull=unsigned long long;

vl sz, parent;
vvl zn;

void changeData(int a, int b){
    zn[a][0]=min(zn[a][0], zn[b][0]);
    zn[a][1]=min(zn[a][1], zn[b][1]);
    zn[a][2]=max(zn[a][2], zn[b][2]);
    zn[a][3]=max(zn[a][3], zn[b][3]);
}

ll findParent(ll v){
    if(v == parent[v]) return v;
    return parent[v] = findParent(parent[v]);
}

void unite(ll a, ll b){
    a=findParent(a);
    b=findParent(b);
    if(a!=b){
        if(sz[a]<sz[b]) swap(a, b);
        sz[a]+=sz[b];
        parent[b]=a;
        changeData(a, b);
    }
}
bool intesect(pair<pl, pl> a, pair<pl, pl> b){
    if(a.S.S<b.F.S || a.F.S>b.S.S || a.F.F>b.S.F || a.S.F<b.F.F){
        return false;
    }
    return true;
}
void solve()
{
    int n, m, k;
    cin>>n>>m>>k;
    vector<pair<pl, pl>> a(k);
    for(int i=0;i<k;i++){
        cin>>a[i].F.F>>a[i].F.S>>a[i].S.F>>a[i].S.S;
        if((a[i].F.F==0 && a[i].F.S==0) || (a[i].S.F==n && a[i].S.S==m)){
            cout<<"YES"<<endl;
        }
    }
    sz.rs(k);
    parent.rs(k);
    zn.rs(k, vl(4));
    for(int i=0;i<k;i++){
        sz[i]=1;
        parent[i]=i;
        zn[i]={a[i].F.F, a[i].F.S, a[i].S.F, a[i].S.S};
    }
    for(int i=0;i<k;i++){
        for(int j=i+1;j<k;j++){
            if(intesect(a[i], a[j])){
                unite(i, j);
            }
        }
    }
    int ans=1;
    for(int i=0;i<k;i++){
        ll x=findParent(i);
        if((zn[x][0]==0 && zn[x][2]==n) || (zn[x][1]==0 && zn[x][3]==m) || (zn[x][0]==0 && zn[x][1]==0) || (zn[x][2]==n && zn[x][3]==m)){
            ans=0;
            break;
        }
    }
    if(ans){
        cout<<"YES"<<endl;
    }
    else{
        cout<<"NO"<<endl;
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
    int t=1;
   // cin>>t;
    while (t--)
        solve();

}
/*

*/
