def check_connected(graph):
    visited = set()
    stack = [graph[0][0]]

    while stack:
        current = stack.pop()
        visited.add(current)

        for edge in graph:
            if current in edge:
                for vertex in edge:
                    if vertex not in visited and vertex != current:
                        stack.append(vertex)

    if len(visited) == len(graph):
        print("YES")
    else:
        print("NO")
        print(1, n)



def create_graph(n):
    graph = []
    for i in range(1,n+1):
        if i+i > n:
            graph.append([i, i + i - n])
        else:
            graph.append([i, i+i])

    return graph
n = int(input())

graph = create_graph(n)

check_connected(graph)
