/*#pragma GCC optimize("O3")
#pragma GCC optimize("unroll-loops")
#pragma GCC target("avx2,popcnt,bmi,bmi2,abm")*/

#include <bits/stdc++.h>

using namespace std;

typedef long long ll;

#define ld long double
#define fr first
#define sc second
#define pll pair<long long, long long>
#define pii pair<int, int>
#define pb push_back

const ll inf=1000000000000000;

ll a[1000000];
pll t[8000000];
ll best[1000001];
pll temp;
int n;

void build(int v, int tl, int tr)
{
    //cout<<tl<<' '<<tr<<'\n';
    if(tl==tr)  { t[v]={a[tl], inf}; return; }
    int tm=(tl+tr)/2;
    build(2*v, tl, tm);
    build(2*v+1, tm+1, tr);
    if(t[2*v].fr<t[2*v+1].fr)   t[v]={t[2*v].fr, min(t[2*v+1].fr, t[2*v].sc)};
    else    t[v]={t[2*v+1].fr, min({t[2*v].sc, t[2*v+1].sc, t[2*v].fr})};
}

pll q(int v, int tl, int tr, int l, int r)
{
    if(tl>r || tr<l)    return {inf, inf};
    if(tl>=l && tr<=r)  return t[v];
    int tm=(tl+tr)/2;
    pll L, R;
    L=q(2*v, tl, tm, l, r);
    R=q(2*v+1, tm+1, tr, l, r);
    if(L.fr<R.fr)   return {L.fr, min(R.fr, L.sc)};
    else    return {R.fr, min({L.sc, R.sc, L.fr})};
}

ll fnd(int l)
{
    if(best[l]) return best[l];
    for(int i=0; i<n-l+1; i++)
    {
        temp=q(1, 0, n-1, i, i+l-1);
        best[l]=max(best[l], temp.fr+temp.sc);
    }
    return best[l];
}

void preprocess()
{

}

void solve()
{
    cin>>n;
    for(int i=0; i<n; i++)  cin>>a[i];
    build(1, 0, n-1);
    //cout<<"norte\n";
    ll ans=-1;
    pll mins;
    for(int i=0; i<n-1; i++)
    {
        best[2]=max(best[2], a[i]+a[i+1]);
    }
    ll iter=2;
    while(iter<=best[2])
    {
        ll l=2, r=n, m;
        while(l!=r)
        {
            m=(l+r+1)/2;
            if(fnd(m)>=iter)    l=m;
            else r=m-1;
        }
        iter=best[l];
        ans=max(ans, iter*l);
        if(l*best[2]<ans)   break;
        iter++;
    }
    /*
    for(int i=0; i<n-1; i++)
    {
        mins={a[i], inf};
        for(int j=i+1; j<n; j++)
        {
            if(a[j]<=mins.fr) { mins.sc=mins.fr; mins.fr=a[j]; }
            else if(a[j]<mins.sc)  { mins.sc=a[j]; }
            ans=max(ans, (mins.fr+mins.sc)*(j-i+1));
        }
    }*/
    cout<<ans<<'\n';
}

int main()
{
    /*ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);*/
    //preprocess();
    int tttt=1;
   // cin>>tttt;
    while(tttt--)
    {
        solve();
    }
    return 0;
}
